## vmemcache 0.8

=== CMakeLists.txt ===
#
# Copyright 2018-2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.3)
project(vmemcache C)

set(VERSION_MAJOR 0)
set(VERSION_MINOR 8)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR})

set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR})

include(FindThreads)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE)

include(CheckCCompilerFlag)
include(GNUInstallDirs)

if(NOT MSVC)
	find_package(PkgConfig QUIET)
	if(NOT PKG_CONFIG_FOUND)
		message(WARNING "Pkg-config not found. Detection of other dependencies may fail.")
	endif()
endif()

if(NOT WIN32)
	if(PKG_CONFIG_FOUND)
		pkg_check_modules(VALGRIND QUIET valgrind)
	else()
		find_package(VALGRIND QUIET)
	endif()

	if (NOT VALGRIND_FOUND)
		message(WARNING "Valgrind not found. Some tests will be skipped.")
	endif()
endif()

find_program(PANDOC NAMES pandoc)
if(NOT PANDOC)
	message(WARNING "pandoc not found - documentation will not be generated")
endif()

set(CMAKE_C_STANDARD 99)

include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(getentropy unistd.h HAVE_GETENTROPY)

# Checks whether flag is supported by current C compiler and appends
# it to the relevant cmake variable.
# 1st argument is a flag
# 2nd (optional) argument is a build type (debug, release, relwithdebinfo)
macro(add_c_flag flag)
	string(REPLACE - _ flag2 ${flag})
	string(REPLACE " " _ flag2 ${flag2})
	string(REPLACE = "_" flag2 ${flag2})
	set(check_name "C_HAS_${flag2}")

	check_c_compiler_flag("${flag}" "${check_name}")

	if (${${check_name}})
		if (${ARGC} EQUAL 1)
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
		else()
			set(CMAKE_C_FLAGS_${ARGV1} "${CMAKE_C_FLAGS_${ARGV1}} ${flag}")
		endif()
	endif()
endmacro()

if(NOT MSVC)
	add_c_flag(-fno-common)
	add_c_flag(-Wall)
	add_c_flag(-Wconversion)
	add_c_flag(-Wmissing-field-initializers)
	add_c_flag(-Wmissing-prototypes)
	add_c_flag(-Wmissing-variable-declarations)
	add_c_flag(-Wpointer-arith)
	add_c_flag(-Wsign-compare)
	add_c_flag(-Wsign-conversion)
	add_c_flag(-Wunused-macros)
	add_c_flag(-Wunreachable-code-return)
	add_c_flag(-Werror=incompatible-pointer-types)

	# Place each function or data item into its own section. Will be used to strip unneeded symbols.
	add_c_flag(-fdata-sections)
	add_c_flag(-ffunction-sections)

	add_c_flag(-ggdb DEBUG)
	add_c_flag(-DDEBUG DEBUG)

	add_c_flag(-ggdb RELWITHDEBINFO)
	add_c_flag(-fno-omit-frame-pointer RELWITHDEBINFO)

	check_c_compiler_flag(-Wl,-z,relro LINKER_HAS_RELRO)
	if(LINKER_HAS_RELRO)
		set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS}  -Wl,-z,relro")
		set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS}  -Wl,-z,relro")
	endif()

	check_c_compiler_flag(-Wl,--warn-common LINKER_HAS_WARN_COMMON)
	if(LINKER_HAS_WARN_COMMON)
		set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -Wl,--warn-common")
		set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--warn-common")
	endif()

	add_c_flag("-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2" RELEASE)
endif()

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

add_executable(check_license EXCLUDE_FROM_ALL utils/check_license/check-license.c)

function(add_cstyle name)
	if(${ARGC} EQUAL 1)
		add_custom_target(cstyle-${name}
			COMMAND ${PERL_EXECUTABLE}
			${CMAKE_SOURCE_DIR}/utils/cstyle
			${CMAKE_CURRENT_SOURCE_DIR}/*.c
			${CMAKE_CURRENT_SOURCE_DIR}/*.h)
	else()
		add_custom_target(cstyle-${name}
			COMMAND ${PERL_EXECUTABLE}
			${CMAKE_SOURCE_DIR}/utils/cstyle ${ARGN})
	endif()
	add_dependencies(cstyle cstyle-${name})
endfunction()

# Generates check-whitespace-$name target and attaches it as a dependency
# of global "check-whitespace" target. This target verifies C files in current
# source dir do not have any whitespace errors.
# If more arguments are used, then they are used as files to be checked
# instead.
# ${name} must be unique.

function(add_check_whitespace name)
	if(${ARGC} EQUAL 1)
		add_custom_target(check-whitespace-${name}
			COMMAND ${PERL_EXECUTABLE}
			${CMAKE_SOURCE_DIR}/utils/check_whitespace
			${CMAKE_CURRENT_SOURCE_DIR}/*.c
			${CMAKE_CURRENT_SOURCE_DIR}/*.h)
	else()
		add_custom_target(check-whitespace-${name}
			COMMAND ${PERL_EXECUTABLE}
			${CMAKE_SOURCE_DIR}/utils/check_whitespace ${ARGN})
	endif()
	add_dependencies(check-whitespace check-whitespace-${name})
endfunction()

add_custom_target(checkers ALL)
add_custom_target(cstyle)
add_custom_target(check-whitespace)
add_custom_target(check-license
	COMMAND ${CMAKE_SOURCE_DIR}/utils/check_license/check-headers.sh
	${CMAKE_SOURCE_DIR}
	${CMAKE_BINARY_DIR}/check_license
	${CMAKE_SOURCE_DIR}/LICENSE
	-a)

add_dependencies(check-license check_license)

add_cstyle(check_license
	${CMAKE_SOURCE_DIR}/utils/check_license/*.c)
add_check_whitespace(check_license
	${CMAKE_SOURCE_DIR}/utils/check_license/*.c)
add_check_whitespace(other
	${CMAKE_SOURCE_DIR}/utils/check_license/*.sh
	${CMAKE_SOURCE_DIR}/README.md)

option(STATS_ENABLED "statistics are enabled" ON)

option(DEVELOPER_MODE "enable developer checks" OFF)
if(DEVELOPER_MODE)
	add_c_flag(-Werror)
	add_dependencies(checkers cstyle)
	add_dependencies(checkers check-whitespace)
	add_dependencies(checkers check-license)
endif(DEVELOPER_MODE)

option(TRACE_TESTS
 	"more verbose test outputs" OFF)

configure_file(libvmemcache.pc.in libvmemcache.pc)
install(FILES ${CMAKE_BINARY_DIR}/libvmemcache.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

enable_testing()
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(benchmarks)
if (PANDOC)
	add_subdirectory(doc)
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/doc/vmemcache.3
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
endif()

if(NOT "${CPACK_GENERATOR}" STREQUAL "")
	include(${CMAKE_SOURCE_DIR}/packages.cmake)
endif()

=== benchmarks/CMakeLists.txt ===
#
# Copyright 2018-2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

add_cstyle(benchmarks
	${CMAKE_SOURCE_DIR}/benchmarks/*.c)

add_check_whitespace(benchmarks
	${CMAKE_SOURCE_DIR}/benchmarks/*.c)

set(SOURCES
	benchmark_time.c
	rand.c
	${CMAKE_SOURCE_DIR}/src/os_posix.c
	${CMAKE_SOURCE_DIR}/src/os_thread_posix.c)

add_executable(bench_micro bench_micro.c ${SOURCES})

target_include_directories(bench_micro PRIVATE
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/tests)

target_link_libraries(bench_micro PRIVATE vmemcache)
target_link_libraries(bench_micro PRIVATE ${CMAKE_THREAD_LIBS_INIT})

add_executable(bench_simul bench_simul.c ${SOURCES})

target_include_directories(bench_simul PRIVATE
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/tests)

if (HAVE_GETENTROPY)
	target_compile_definitions(bench_simul PRIVATE HAVE_GETENTROPY)
endif()

if(STATS_ENABLED)
	target_compile_definitions(bench_simul PRIVATE STATS_ENABLED=1)
endif()

target_link_libraries(bench_simul PRIVATE vmemcache)
target_link_libraries(bench_simul PRIVATE ${CMAKE_THREAD_LIBS_INIT})

=== doc/CMakeLists.txt ===
#
# Copyright 2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

add_custom_target(doc ALL
	BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/vmemcache.3
	COMMENT "Building vmemcache.3"
	COMMAND ${CMAKE_SOURCE_DIR}/utils/md2man/md2man.sh
		${CMAKE_CURRENT_SOURCE_DIR}/vmemcache.md
		${CMAKE_SOURCE_DIR}/utils/md2man/default.man
		${CMAKE_CURRENT_BINARY_DIR}/vmemcache.3
	)

=== src/CMakeLists.txt ===
#
# Copyright 2018-2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.3)
project(vmemcache C)

add_cstyle(src)
add_check_whitespace(src)

set(SOURCES
	out.c
	os_posix.c
	os_thread_posix.c
	util.c
	util_posix.c
	file.c
	file_posix.c
	mmap.c
	mmap_posix.c
	libvmemcache.c
	critnib.c
	ringbuf.c
	vmemcache.c
	vmemcache_heap.c
	vmemcache_index.c
	vmemcache_repl.c)

add_library(vmemcache SHARED ${SOURCES})
target_link_libraries(vmemcache PRIVATE
	${CMAKE_THREAD_LIBS_INIT}
	-Wl,--version-script=${CMAKE_SOURCE_DIR}/src/libvmemcache.map)
set_target_properties(vmemcache PROPERTIES SOVERSION 0)

target_compile_definitions(vmemcache PRIVATE SRCVERSION="${VERSION}")

if(STATS_ENABLED)
	target_compile_definitions(vmemcache PRIVATE STATS_ENABLED=1)
endif()

if(VALGRIND_FOUND)
	target_compile_definitions(vmemcache PRIVATE VALGRIND_ENABLED=1)
endif()

install(TARGETS vmemcache
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/)
install(FILES libvmemcache.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== tests/CMakeLists.txt ===
#
# Copyright 2018-2019, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#
#     * Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

set(DEFAULT_TEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/test)

set(TEST_DIR ${DEFAULT_TEST_DIR}
	CACHE STRING "directory for vmemcache memory pool used for tests")

set(DEVICE_DAX_PATH "" CACHE STRING
	"raw DAX device without a file system for tests. Example: /dev/dax0.0")

set(GLOBAL_TEST_ARGS -DPARENT_DIR=${TEST_DIR}/)

if(TRACE_TESTS)
	set(GLOBAL_TEST_ARGS ${GLOBAL_TEST_ARGS} --trace-expand)
endif()

add_cstyle(tests)
add_check_whitespace(tests)

set(vg_tracers memcheck helgrind drd)

# Configures test ${name}
function(test name file tracer location)
	if (${tracer} IN_LIST vg_tracers)
		if (NOT VALGRIND_FOUND)
			message(WARNING
				"Valgrind not found, test skipped: ${name}")
			return()
		endif()
		if (COVERAGE_BUILD)
			message(STATUS
				"This is the Coverage build, skipping Valgrind test: ${name}")
			return()
		endif()
	endif()

	if ((COVERAGE_BUILD) AND (${tracer} STREQUAL helgrind))
		message(STATUS "This is the Coverage build, skipping Helgrind test: ${name}")
		return()
	endif()

	if(${location} STREQUAL fs)
		set(TEST_POOL_LOCATION ${TEST_DIR})
	elseif(${location} STREQUAL ddax)
		set(TEST_POOL_LOCATION ${DEVICE_DAX_PATH})
	else()
		message(FATAL_ERROR "Unknown pool's location: ${location}")
		return()
	endif()

	add_test(NAME ${name}
		COMMAND ${CMAKE_COMMAND}
		${GLOBAL_TEST_ARGS}
		-DTEST_NAME=${name}
		-DSRC_DIR=${CMAKE_CURRENT_SOURCE_DIR}
		-DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR}/${file}-${tracer}-${location}
		-DCONFIG=$<CONFIG>
		-DTRACER=${tracer}
		-DTEST_POOL_LOCATION=${TEST_POOL_LOCATION}
		-P ${CMAKE_CURRENT_SOURCE_DIR}/${file}.cmake)

	set_tests_properties(${name} PROPERTIES
		ENVIRONMENT "LC_ALL=C;PATH=$ENV{PATH}"
		TIMEOUT 300)
endfunction()

# add and link an executable
function(add_link_executable name sources libs)
	add_executable(${name} ${sources})
	target_include_directories(${name} PRIVATE ${CMAKE_SOURCE_DIR}/src)
	if(STATS_ENABLED)
		target_compile_definitions(${name} PRIVATE STATS_ENABLED=1)
	endif()
	target_link_libraries(${name} PRIVATE ${libs})
endfunction()

set(SOURCES_BASIC
	vmemcache_test_basic.c)

set(SOURCES_MT
	vmemcache_test_mt.c
	${CMAKE_SOURCE_DIR}/src/os_posix.c
	${CMAKE_SOURCE_DIR}/src/os_thread_posix.c)

set(SOURCES_UTLIIZATION
	vmemcache_test_utilization.c)

set(SOURCES_HEAP_USAGE
	vmemcache_test_heap_usage.c)

set(SOURCES_EXAMPLE
	example.c)

set(LIBS_BASIC
	vmemcache)

set(LIBS_MT
	vmemcache
	${CMAKE_THREAD_LIBS_INIT})

set(LIBS_UTLIIZATION
	vmemcache
	m)

set(LIBS_HEAP_USAGE
	vmemcache
	${CMAKE_DL_LIBS})

set(LIBS_EXAMPLE
	vmemcache)

add_link_executable(vmemcache_test_basic
		"${SOURCES_BASIC}"
		"${LIBS_BASIC}")

add_link_executable(vmemcache_test_mt
		"${SOURCES_MT}"
		"${LIBS_MT}")

add_link_executable(vmemcache_test_utilization
		"${SOURCES_UTLIIZATION}"
		"${LIBS_UTLIIZATION}")

add_link_executable(example
		"${SOURCES_EXAMPLE}"
		"${LIBS_EXAMPLE}")

add_link_executable(vmemcache_test_heap_usage
		"${SOURCES_HEAP_USAGE}"
		"${LIBS_HEAP_USAGE}")

if(NOT "${TEST_DIR}" STREQUAL "")
	test("FS-test-basic" test-basic none fs)
	test("FS-test-basic-memcheck" test-basic memcheck fs)
	test("FS-test-mt" test-mt none fs)
	test("FS-test-mt-memcheck" test-mt memcheck fs)
	test("FS-test-mt-helgrind" test-mt helgrind fs)
	test("FS-test-mt-drd" test-mt drd fs)
	test("FS-test-bench-mt" test-bench-mt none fs)
	test("FS-test-bench-simul" test-bench-simul none fs)
	test("FS-test-bench-simul-memcheck" test-bench-simul memcheck fs)
	test("FS-test-bench-simul-helgrind" test-bench-simul helgrind fs)
	test("FS-test-bench-simul-drd" test-bench-simul drd fs)
	test("FS-test-utilization" test-utilization none fs)
	test("FS-test-utilization-memcheck" test-utilization memcheck fs)
	test("FS-test-heap-usage" test-heap-usage none fs)
	test("FS-test-heap-usage-memcheck" test-heap-usage memcheck fs)
endif()

if(NOT "${DEVICE_DAX_PATH}" STREQUAL "")
	test("DDAX-test-basic" test-basic none ddax)
	test("DDAX-test-basic-memcheck" test-basic memcheck ddax)
	test("DDAX-test-mt" test-mt none ddax)
	test("DDAX-test-mt-memcheck" test-mt memcheck ddax)
	test("DDAX-test-mt-helgrind" test-mt helgrind ddax)
	test("DDAX-test-mt-drd" test-mt drd ddax)
	test("DDAX-test-bench-mt" test-bench-mt none ddax)
	test("DDAX-test-bench-simul" test-bench-simul none ddax)
	test("DDAX-test-bench-simul-memcheck" test-bench-simul memcheck ddax)
	test("DDAX-test-bench-simul-helgrind" test-bench-simul helgrind ddax)
	test("DDAX-test-bench-simul-drd" test-bench-simul drd ddax)
	test("DDAX-test-utilization" test-utilization none ddax)
	test("DDAX-test-utilization-memcheck" test-utilization memcheck ddax)
	test("DDAX-test-heap-usage" test-heap-usage none ddax)
	test("DDAX-test-heap-usage-memcheck" test-heap-usage memcheck ddax)
endif()

test("example" test-example none fs)

=== debian/changelog ===
vmemcache (0.8-4) unstable; urgency=medium

  * Install the man page.
  * Fix an intermittent test failure on 32-bit.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 19 Jul 2019 01:45:46 +0200

vmemcache (0.8-3) unstable; urgency=medium

  * Hard-code -latomic.
  * Avoid some Linuxisms.
  * Handle missing PATH_MAX.
  * Don't assume hard-coded sizes of pthread types.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 02 May 2019 17:31:06 +0200

vmemcache (0.8-2) unstable; urgency=medium

  * Unbreak tests on 32-bit archs.
  * Migrate from __sync_fetch to __atomic_fetch, link with -latomic.
  * Don't Build-Depend on valgrind on archs that lack it.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 Apr 2019 15:25:03 +0200

vmemcache (0.8-1) unstable; urgency=medium

  * Initial release (Closes: #925980)

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 29 Mar 2019 19:00:34 +0100

=== debian/control ===
Source: vmemcache
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends:
	cmake,
	debhelper (>= 11),
	pandoc,
	pkg-config,
	valgrind [amd64 arm64 armhf i386 mips mipsel mips64 mips64el powerpc ppc64 ppc64el s390x x32]
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/pmem/vmemcache
Vcs-Browser: https://github.com/kilobyte/vmemcache/tree/debian
Vcs-Git: https://github.com/kilobyte/vmemcache -b debian

Package: libvmemcache-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libvmemcache0 (= ${binary:Version}), ${misc:Depends}
Description: buffer-based LRU cache
 Vmemcache is a volatile filesystem based key:value cache.  It works best
 when backed with a DAX-capable persistent memory device, but can work on
 tmpfs or on legacy disks.
 .
 This package contains development headers and documentation.

Package: libvmemcache0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: buffer-based LRU cache
 Vmemcache is a volatile filesystem based key:value cache.  It works best
 when backed with a DAX-capable persistent memory device, but can work on
 tmpfs or on legacy disks.
 .
 This package contains the runtime library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -latomic


%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%vmemcache-$1.tar.gz%" \
   https://github.com/pmem/vmemcache/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## vmemcache 0.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,33 +1,5 @@
-#
+# SPDX-License-Identifier: BSD-3-Clause
 # Copyright 2018-2019, Intel Corporation
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-#     * Redistributions of source code must retain the above copyright
-#       notice, this list of conditions and the following disclaimer.
-#
-#     * Redistributions in binary form must reproduce the above copyright
-#       notice, this list of conditions and the following disclaimer in
-#       the documentation and/or other materials provided with the
-#       distribution.
-#
-#     * Neither the name of the copyright holder nor the names of its
-#       contributors may be used to endorse or promote products derived
-#       from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.3)
 project(vmemcache C)
@@ -103,12 +75,14 @@
 	add_c_flag(-fno-common)
 	add_c_flag(-Wall)
 	add_c_flag(-Wconversion)
+	add_c_flag(-Wfloat-equal)
 	add_c_flag(-Wmissing-field-initializers)
 	add_c_flag(-Wmissing-prototypes)
 	add_c_flag(-Wmissing-variable-declarations)
 	add_c_flag(-Wpointer-arith)
 	add_c_flag(-Wsign-compare)
 	add_c_flag(-Wsign-conversion)
+	add_c_flag(-Wswitch-default)
 	add_c_flag(-Wunused-macros)
 	add_c_flag(-Wunreachable-code-return)
 	add_c_flag(-Werror=incompatible-pointer-types)
@@ -145,8 +119,6 @@
 
 add_custom_target(uninstall
 	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
-
-add_executable(check_license EXCLUDE_FROM_ALL utils/check_license/check-license.c)
 
 function(add_cstyle name)
 	if(${ARGC} EQUAL 1)
@@ -191,16 +163,8 @@
 add_custom_target(check-license
 	COMMAND ${CMAKE_SOURCE_DIR}/utils/check_license/check-headers.sh
 	${CMAKE_SOURCE_DIR}
-	${CMAKE_BINARY_DIR}/check_license
-	${CMAKE_SOURCE_DIR}/LICENSE
-	-a)
-
-add_dependencies(check-license check_license)
-
-add_cstyle(check_license
-	${CMAKE_SOURCE_DIR}/utils/check_license/*.c)
-add_check_whitespace(check_license
-	${CMAKE_SOURCE_DIR}/utils/check_license/*.c)
+	BSD-3-Clause)
+
 add_check_whitespace(other
 	${CMAKE_SOURCE_DIR}/utils/check_license/*.sh
 	${CMAKE_SOURCE_DIR}/README.md)
@@ -212,7 +176,6 @@
 	add_c_flag(-Werror)
 	add_dependencies(checkers cstyle)
 	add_dependencies(checkers check-whitespace)
-	add_dependencies(checkers check-license)
 endif(DEVELOPER_MODE)
 
 option(TRACE_TESTS

=== benchmarks/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2018-2019, Intel Corporation

add_cstyle(benchmarks
	${CMAKE_SOURCE_DIR}/benchmarks/*.c)

add_check_whitespace(benchmarks
	${CMAKE_SOURCE_DIR}/benchmarks/*.c)

set(SOURCES
	benchmark_time.c
	rand.c
	${CMAKE_SOURCE_DIR}/src/os_posix.c
	${CMAKE_SOURCE_DIR}/src/os_thread_posix.c)

add_executable(bench_micro bench_micro.c ${SOURCES})

target_include_directories(bench_micro PRIVATE
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/tests)

target_link_libraries(bench_micro PRIVATE vmemcache)
target_link_libraries(bench_micro PRIVATE ${CMAKE_THREAD_LIBS_INIT})

add_executable(bench_simul bench_simul.c ${SOURCES})

target_include_directories(bench_simul PRIVATE
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/tests)

if (HAVE_GETENTROPY)
	target_compile_definitions(bench_simul PRIVATE HAVE_GETENTROPY)
endif()

if(STATS_ENABLED)
	target_compile_definitions(bench_simul PRIVATE STATS_ENABLED=1)
endif()

target_link_libraries(bench_simul PRIVATE vmemcache)
target_link_libraries(bench_simul PRIVATE ${CMAKE_THREAD_LIBS_INIT})

=== doc/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2019, Intel Corporation

add_custom_target(doc ALL
	BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/vmemcache.3
	COMMENT "Building vmemcache.3"
	COMMAND ${CMAKE_SOURCE_DIR}/utils/md2man/md2man.sh
		${CMAKE_CURRENT_SOURCE_DIR}/vmemcache.md
		${CMAKE_SOURCE_DIR}/utils/md2man/default.man
		${CMAKE_CURRENT_BINARY_DIR}/vmemcache.3
	)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2018-2019, Intel Corporation

cmake_minimum_required(VERSION 3.3)
project(vmemcache C)

add_cstyle(src)
add_check_whitespace(src)

set(SOURCES
	out.c
	os_posix.c
	os_thread_posix.c
	util.c
	util_posix.c
	file.c
	file_posix.c
	fast-hash.c
	mmap.c
	mmap_posix.c
	libvmemcache.c
	critnib.c
	ringbuf.c
	vmemcache.c
	vmemcache_heap.c
	vmemcache_index.c
	vmemcache_repl.c)

add_library(vmemcache SHARED ${SOURCES})
target_link_libraries(vmemcache PRIVATE
	${CMAKE_THREAD_LIBS_INIT}
	-Wl,--version-script=${CMAKE_SOURCE_DIR}/src/libvmemcache.map)
set_target_properties(vmemcache PROPERTIES SOVERSION 0)

target_compile_definitions(vmemcache PRIVATE SRCVERSION="${VERSION}")

if(STATS_ENABLED)
	target_compile_definitions(vmemcache PRIVATE STATS_ENABLED=1)
endif()

if(VALGRIND_FOUND)
	target_compile_definitions(vmemcache PRIVATE VALGRIND_ENABLED=1)
endif()

install(TARGETS vmemcache
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/)
install(FILES libvmemcache.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,33 +1,5 @@
-#
+# SPDX-License-Identifier: BSD-3-Clause
 # Copyright 2018-2019, Intel Corporation
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-#     * Redistributions of source code must retain the above copyright
-#       notice, this list of conditions and the following disclaimer.
-#
-#     * Redistributions in binary form must reproduce the above copyright
-#       notice, this list of conditions and the following disclaimer in
-#       the documentation and/or other materials provided with the
-#       distribution.
-#
-#     * Neither the name of the copyright holder nor the names of its
-#       contributors may be used to endorse or promote products derived
-#       from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 set(DEFAULT_TEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/test)
 
@@ -61,11 +33,6 @@
 				"This is the Coverage build, skipping Valgrind test: ${name}")
 			return()
 		endif()
-	endif()
-
-	if ((COVERAGE_BUILD) AND (${tracer} STREQUAL helgrind))
-		message(STATUS "This is the Coverage build, skipping Helgrind test: ${name}")
-		return()
 	endif()
 
 	if(${location} STREQUAL fs)
@@ -120,6 +87,9 @@
 set(SOURCES_EXAMPLE
 	example.c)
 
+set(SOURCES_TWOLEVEL
+	twolevel.c)
+
 set(LIBS_BASIC
 	vmemcache)
 
@@ -136,6 +106,9 @@
 	${CMAKE_DL_LIBS})
 
 set(LIBS_EXAMPLE
+	vmemcache)
+
+set(LIBS_TWOLEVEL
 	vmemcache)
 
 add_link_executable(vmemcache_test_basic
@@ -158,6 +131,10 @@
 		"${SOURCES_HEAP_USAGE}"
 		"${LIBS_HEAP_USAGE}")
 
+add_link_executable(twolevel
+		"${SOURCES_TWOLEVEL}"
+		"${LIBS_TWOLEVEL}")
+
 if(NOT "${TEST_DIR}" STREQUAL "")
 	test("FS-test-basic" test-basic none fs)
 	test("FS-test-basic-memcheck" test-basic memcheck fs)
@@ -174,6 +151,7 @@
 	test("FS-test-utilization-memcheck" test-utilization memcheck fs)
 	test("FS-test-heap-usage" test-heap-usage none fs)
 	test("FS-test-heap-usage-memcheck" test-heap-usage memcheck fs)
+	test("FS-test-twolevel" test-twolevel none fs)
 endif()
 
 if(NOT "${DEVICE_DAX_PATH}" STREQUAL "")

=== debian/changelog ===
vmemcache (0.8.1-4) unstable; urgency=medium

  * Give up trying to support 32-bit.  There's no pmem hardware there,
    and won't ever be.  The library is meant for multi-terabyte datasets
    (or shards of even bigger stuff), so 32-bit chroots make little sense,
    either.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 20 Nov 2020 07:04:46 +0100

vmemcache (0.8.1-3) unstable; urgency=medium

  * Disable valgrind tests on mips64* (fails on glibc code).
  * Fix -latomic linkage on m68k.
  * Fix test failure on 32-bit that is also bad-endian.
    You can guess my level of motivation for platforms that are not ever
    going to get pmem hardware...

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 11 Nov 2020 02:37:13 +0100

vmemcache (0.8.1-2) unstable; urgency=medium

  * Fix FTBFS on 32-bit and bad-endian.
  * Fix -latomic linkage (closes: #972967), thanks Adrian Bunk.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 11 Nov 2020 00:04:28 +0100

vmemcache (0.8.1-1) unstable; urgency=medium

  * New upstream point release.
  * dh 12.
  * Add vmemcache_exists to symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 21 Oct 2020 16:10:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Maintainer: Adam Borowski <kilobyte@angband.pl>
 Build-Depends:
 	cmake,
-	debhelper (>= 11),
+	debhelper-compat (= 12),
 	pandoc,
 	pkg-config,
-	valgrind [amd64 arm64 armhf i386 mips mipsel mips64 mips64el powerpc ppc64 ppc64el s390x x32]
-Standards-Version: 4.3.0
+	valgrind [amd64 arm64 armhf i386 powerpc ppc64el x32]
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/pmem/vmemcache
 Vcs-Browser: https://github.com/kilobyte/vmemcache/tree/debian
@@ -15,7 +15,7 @@
 
 Package: libvmemcache-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64el mips64el s390x alpha ia64 ppc64 riscv64 sparc64
 Multi-Arch: same
 Depends: libvmemcache0 (= ${binary:Version}), ${misc:Depends}
 Description: buffer-based LRU cache
@@ -26,7 +26,7 @@
  This package contains development headers and documentation.
 
 Package: libvmemcache0
-Architecture: any
+Architecture: amd64 arm64 ppc64el mips64el s390x alpha ia64 ppc64 riscv64 sparc64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: buffer-based LRU cache

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel powerpc m68k))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif


%:
	dh $@

=== debian/tests/control ===
Test-Command: gcc -Wall -o "$AUTOPKGTEST_TMP"/example tests/example.c -lvmemcache && "$AUTOPKGTEST_TMP"/example
Features: test-name=gcc
Depends: gcc, libc-dev, make, libvmemcache-dev

Test-Command: clang -Wall -o "$AUTOPKGTEST_TMP"/example tests/example.c -lvmemcache && "$AUTOPKGTEST_TMP"/example
Features: test-name=clang
Depends: clang, libc-dev, make, libvmemcache-dev
Restrictions: skip-not-installable

Test-Command: tcc -Wall -o "$AUTOPKGTEST_TMP"/example tests/example.c -lvmemcache && "$AUTOPKGTEST_TMP"/example
Features: test-name=tcc
Depends: tcc, libc-dev, make, libvmemcache-dev
Restrictions: skip-not-installable
